summaryrefslogtreecommitdiffstats
path: root/package/6in4/files/6in4.hotplug
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2010-05-28 22:03:30 +0000
committerJo-Philipp Wich <jow@openwrt.org>2010-05-28 22:03:30 +0000
commit0bd7c654472835f967d1741d64ab853a987ea758 (patch)
treefd0167d4f9fb8d584148a55cf2921753f5f24510 /package/6in4/files/6in4.hotplug
parent8dd583e3a40ae2e19677e33b3aad9695ac33e8b9 (diff)
downloadmaster-31e0f0ae-0bd7c654472835f967d1741d64ab853a987ea758.tar.gz
master-31e0f0ae-0bd7c654472835f967d1741d64ab853a987ea758.tar.bz2
master-31e0f0ae-0bd7c654472835f967d1741d64ab853a987ea758.zip
6in4: - support to automatically determine the local endpoint address from the current IPv4 default gateway - support updating the tunnel endpoint for he.net
SVN-Revision: 21612
Diffstat (limited to 'package/6in4/files/6in4.hotplug')
-rw-r--r--package/6in4/files/6in4.hotplug44
1 files changed, 44 insertions, 0 deletions
diff --git a/package/6in4/files/6in4.hotplug b/package/6in4/files/6in4.hotplug
new file mode 100644
index 0000000000..0a196c25b0
--- /dev/null
+++ b/package/6in4/files/6in4.hotplug
@@ -0,0 +1,44 @@
+#!/bin/sh
+
+if [ "$ACTION" = ifup ]; then
+ . /etc/functions.sh
+
+ include /lib/network
+ scan_interfaces
+
+ update_tunnel() {
+ local cfg="$1"
+
+ local proto
+ config_get proto "$cfg" proto
+ [ "$proto" = 6in4 ] || return 0
+
+ local wandev
+ config_get wandev "$cfg" wan_device
+ [ "$wandev" = "$DEVICE" ] || return 0
+
+ local oldip
+ local wanip=$(find_6in4_wanip "$wandev")
+ config_get oldip "$cfg" ipaddr
+
+ [ -n "$wanip" ] && [ "$oldip" != "$wanip" ] && {
+ local tunnelid
+ config_get tunnelid "$cfg" tunnelid
+
+ local username
+ config_get username "$cfg" username
+
+ local password
+ config_get password "$cfg" password
+
+ [ -n "$tunnelid" ] && [ -n "$username" ] && [ -n "$password" ] && {
+ password="$(echo -n "$password" | md5sum)"; password="${password%% *}"
+ uci_set_state network "$cfg" ipaddr "$wanip"
+
+ ( wget -qO/dev/null "http://ipv4.tunnelbroker.net/ipv4_end.php?ipv4b=AUTO&user_id=$username&pass=$password&tunnel_id=$tunnelid" && ifup "$cfg" )&
+ }
+ }
+ }
+
+ config_foreach update_tunnel interface
+fi